/*****************************************************************************
**                      Copyright  (C)  WCH  2001-2022                      **
**                      Web:  http://wch.cn                                 **
******************************************************************************
Abstract:
  EditؼдʵʮƱ༭
Environment:
    user mode only,VC6.0 and later
Notes:
  Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
  SPDX-License-Identifier: Apache-2.0
Revision History:
  4/3/2022: V.100 TECH30
--*/

#include "Main.h"
#include <richedit.h>


static BOOL ShiftStatus=FALSE,DelKeyStatus;
CHAR DelHexCharIndex,DelHexCharCount;
WNDPROC OldEditWndProc; //ؼԭд
ULONG EditCnt=0;

//ò״Ϊ
void SetCaretShap(HWND DialogHWND,ULONG CtrlID)
{
	
    HANDLE iFnt;
    HDC hdc5;
	ULONG SelStart,SelEnd;
    SIZE sz;
    ULONG  width5, height5;
	CHAR aChar,tem[100]="";
	TEXTRANGE txr={0};
	    
	HWND CtlHwnd;
	DestroyCaret();
	CtlHwnd = GetDlgItem(DialogHWND,CtrlID);
    iFnt = (HANDLE)SendDlgItemMessage(DialogHWND,CtrlID,WM_GETFONT,0,0);
    hdc5 = GetDC(CtlHwnd);
    SelectObject(hdc5, iFnt);  //ʾ
    
	aChar = 0;
	SendDlgItemMessage(DialogHWND,CtrlID,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
	txr.chrg.cpMin=SelStart-1;
	txr.chrg.cpMax=SelStart;
	txr.lpstrText = &aChar;
	SendDlgItemMessage(DialogHWND,CtrlID,WM_GETTEXT,10,(ULONG)tem);
	aChar = tem[0];//tem[SelStart-1];
    
    if(aChar == 0)//text棬CaretλûԪ
	{
        if(SelStart > 1)
		{
			txr.chrg.cpMin=SelStart-1;
			txr.chrg.cpMax=SelStart;
			txr.lpstrText = &aChar;
			SendDlgItemMessage(DialogHWND,CtrlID,EM_EXGETSEL,0,(ULONG)&txr);
		}
        else
            aChar = 'x'; //ڶԪx,ѡȡĬϵ        
    }
    GetTextExtentPoint32(hdc5, &aChar, 1, &sz); //ȡøԪĳ
	
    width5 = sz.cx;
    height5 = sz.cy;
    ReleaseDC(DialogHWND, hdc5);
    CreateCaret(CtlHwnd,NULL,width5, height5);//Create Caret
    ShowCaret(CtlHwnd);     //ʾCaret
}

long CALLBACK NewEditWndProc(IN HWND   WindowHandle,
							 IN UINT   Message,
							 IN WPARAM WParam,
							 IN LPARAM LParam)  
{
	ULONG SelStart=0,SelEnd=0,EditCtlId;
	HWND ParentHwnd; //ؼڴ

	EditCtlId = GetWindowLong(WindowHandle,GWL_ID);	
	ParentHwnd = (HWND)GetWindowLong(WindowHandle,GWL_HWNDPARENT);
	switch (Message) { 
	case WM_RBUTTONDOWN:
	case  WM_LBUTTONDBLCLK:
	case WM_LBUTTONDOWN  :
	case WM_LBUTTONUP:
	case WM_MBUTTONDBLCLK  :
	case WM_MBUTTONDOWN  :
	case WM_MBUTTONUP  :
		{
			ULONG SelStart,SelEnd,x;
			SetCaretShap(ParentHwnd,EditCtlId);
			if( (Message == WM_LBUTTONDOWN)||(Message == WM_MBUTTONDOWN) )//ƶmouseʱ,һʮֻ1ַʱ,Զһ0
			{
				SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
				x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));
				if( (x>0)&&( (x-1)%3 == 0 )&&(SelStart==x) )
				{
					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,x,x);
					SendMessage(GetDlgItem(ParentHwnd,EditCtlId),WM_CHAR,(ULONG)'0',1);
				}
			}
			{//ڿո,Զһַ
				x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));
				SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
				if( (x!=SelStart)&&( !((SelStart+1)%3) ) )
					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,SelStart-1,SelEnd-1);
			}
		}
		return (CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam)); 
	case WM_CHAR: 
		{
			CHAR tem[100]="";
			CHAR chCharCode = (TCHAR) WParam;    // character code 
			ULONG lKeyData = LParam,x;              // key data 

			if( !(((chCharCode>='0')&&(chCharCode<='9')) ||//Чʮַ,
				((chCharCode>='A')&&(chCharCode<='F')) ||
				((chCharCode>='a')&&(chCharCode<='f'))) )
			{
				if(chCharCode==VK_BACK)
					CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam);
				return 0;
			}
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
			x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));
			if( (x!=SelStart)  ) //޸,ҪǰӲλ
			{
				if( (SelStart+1)%3 == 0 )
				{
					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,SelStart+1,SelEnd+1);
				}
			}
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);

			//VK_BACK,VK_DELETEɾַʱ,ͣڿոʱԶǰһ,֤ͣڿոǰ.
			if( ((SelStart>1)&&( !((SelStart+1)%3)&&(chCharCode!=VK_BACK)&&(chCharCode!=VK_DELETE) ) ) )
			{				
				CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,' ',3735553);
			}
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
			if( (SelStart+1)%3==0 )
				SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,SelStart+1,SelEnd+1);
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
			x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));
			//ͣڿո,ԶƵһλ
			if(x!=SelEnd)
			{
				SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,(ULONG)(SelStart+1),(ULONG)(SelEnd) );				
			}
			CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam);
		}	
		break;
	case WM_KEYDOWN:
		{
			ULONG x,chCharCode,nVirtKey = (int) WParam;
			CHAR tem[100]="";
			ULONG SelStart,SelEnd;

			SetCaretShap(ParentHwnd,EditCtlId);
			chCharCode = nVirtKey;					

			x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
			if( (x==SelStart)&&( !((SelStart+1)%3) )&&((nVirtKey==VK_UP)||(nVirtKey==VK_DOWN)) )
				SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,SelStart-1,SelEnd-1);

			if( (nVirtKey== VK_RETURN)||(nVirtKey== VK_CONTROL) )//ûسctrl
				return 0;
			if( (nVirtKey==VK_LEFT) || (nVirtKey==VK_RIGHT) ||(nVirtKey==VK_UP) ||
				(nVirtKey==VK_DOWN) ||(nVirtKey==VK_HOME) ||(nVirtKey==VK_END) )
			{
				SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
				x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));
				if( ( (x-1)%3 == 0 )&&(SelStart==x) )
				{
					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,x,x);
					SendMessage(GetDlgItem(ParentHwnd,EditCtlId),WM_CHAR,(ULONG)'0',LParam);
					//return 0;
				}
			}
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
			//ѡVK_BACKɾ,ɾԪʮַһո
			if( (nVirtKey== VK_BACK) )
			{
				x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));					
				if(!DelHexCharIndex)//ɾʮַӿոеĿո
				{						
					if(SelStart==0)//,ɾ
						DelHexCharCount = 0;
					else if( (x-SelStart)<2 )//һʮַ,֤һַǿո
					{
						DelHexCharCount = 2;
						SelStart+=3;						
						SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,(ULONG)SelStart,(ULONG)SelStart);
					}
					else if( ((SelStart-1)%3==0) )//ʮַм,Ƶַ
					{						
						SelStart+=2;						
						SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,(ULONG)SelStart,(ULONG)SelStart);
						DelHexCharCount = 3;
					}	
					else 
					{
						DelHexCharCount = 3;
					}

					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
					if( (SelStart%3)==0 )//ʮַǰ,ɾǰһʮƶַһո
					{						
						PostMessage(GetDlgItem(ParentHwnd,EditCtlId),WM_KEYDOWN,VK_BACK,LParam);
						DelHexCharIndex++;
						DelHexCharIndex++;
						return 0;
					}
				}
				if(DelHexCharIndex<DelHexCharCount){//ɾʮƵڶַ												
					PostMessage(GetDlgItem(ParentHwnd,EditCtlId),WM_KEYDOWN,VK_BACK,LParam);
					DelHexCharIndex++;
					return 0;
				}
				else if(DelHexCharIndex >=DelHexCharCount )//ɾʮƵһַ
				{
					DelHexCharIndex = 0;
					return 0;
				}					
			}				
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
			//ѡVK_DELETEɾ,ɾԪʮַһո
			if( (nVirtKey== VK_DELETE) )
			{
				if( !DelHexCharIndex )//ɾʮַеĵһַ
				{
					x = GetWindowTextLength(GetDlgItem(ParentHwnd,EditCtlId));

					if( (x-SelStart)==1 )//ͣһֽ
					{
						SelStart-=2;								
					}
					if( (x-SelStart)==2 )//ͣһֽ
					{
						SelStart-=1;						
					}
					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,(ULONG)SelStart,(ULONG)SelStart);
					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
					if( !((SelStart-1)%3) )//ͣʮַм
					{
						SelStart-=1;
						SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,(ULONG)SelStart,(ULONG)SelStart);
					}
					DelHexCharCount = 3;

					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
					if( !(SelStart%3) )
					{
						DelHexCharIndex++;
						PostMessage(GetDlgItem(ParentHwnd,EditCtlId),WM_KEYDOWN,VK_DELETE,LParam);						
						CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam); 						
						return 0;
					}
				}					
				if(DelHexCharIndex<DelHexCharCount){//ɾʮַеĵڶַ
					DelHexCharIndex++;
					PostMessage(GetDlgItem(ParentHwnd,EditCtlId),WM_KEYDOWN,VK_DELETE,LParam);
					CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam); 
					return 0;
				}
				else if(DelHexCharIndex >=DelHexCharCount )//ɾʮַеĿո
				{
					DelHexCharCount = DelHexCharIndex = 0;
					return 0;
				}					
			}				
			DelHexCharCount = DelHexCharIndex = 0;
			SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
			if( (nVirtKey== VK_LEFT) )//ֹƵոǰ
			{
				if( (SelStart%3)==0 )
				{
					if(!ShiftStatus)//ֹVK_SHIFT+VK_LEFT
						SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,SelStart-1,SelEnd-1);
				}
			}
			if(nVirtKey== VK_RIGHT)//ֹƵոǰ
			{
				if( (((SelStart-1)%3)==0) && (SelStart>0) )
				{
					if(!ShiftStatus)//ֹVK_SHIFT+VK_RIGHT
						SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,SelStart+1,SelEnd+1);
				}
			}								
			{//SHIFTVK_LEFT,VK_RIGHT,VK_UP,VK_DOWN
				if(nVirtKey == VK_SHIFT) //ѰVK_SHIFT
				{
					ShiftStatus = TRUE;					
				}
				if( ShiftStatus && (
					( (nVirtKey>0x24)&&(nVirtKey<0x29) ) ||
					( nVirtKey == VK_HOME ) ||
					( nVirtKey == VK_END ) )
					)
					return 0;					
			}
		}
		CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam); 
		break;
	case WM_KEYUP:
		{
			ULONG SelStart,SelEnd;
			int nVirtKey = (int) WParam;	


			if(nVirtKey == VK_SHIFT)//ͷVK_SHIFT
			{
				ShiftStatus = FALSE;
			}	
			if( (((nVirtKey>='0')&&(nVirtKey<='9')) ||
				((nVirtKey>='A')&&(nVirtKey<='F')) ||
				((nVirtKey>='a')&&(nVirtKey<='f'))) )
			{
				SendDlgItemMessage(ParentHwnd,EditCtlId,EM_GETSEL,(ULONG)&SelStart,(ULONG)&SelEnd);
				//ͣڿո,ԶƵһλ
				if(!((SelStart+1)%3))//ʱ,Ƶոǰʱ,һַǰ
				{						
					SendDlgItemMessage(ParentHwnd,EditCtlId,EM_SETSEL,(ULONG)(SelStart+1),(ULONG)(SelEnd+1) );
				}
			}
		}
		CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam); 

		break;
	default:
		return (CallWindowProc((WNDPROC)OldEditWndProc,WindowHandle,Message,WParam,LParam)); 
	}
	return 0;
}

//EDITؼıʮ
VOID SetEditlInputMode(
					   HWND hWnd,       // handle of window
					   ULONG CtrlID,    //ؼID
					   UCHAR InputMode //ģʽ:0:ıģʽ,1:ʮģʽ
					   )
{	
	if ( ( InputMode == 0 ) && ( OldEditWndProc != 0 ) )//ıģʽ
	{
		SetWindowLong(GetDlgItem(hWnd,CtrlID),GWL_USERDATA,0);
		SetWindowLong(GetDlgItem(hWnd,CtrlID),GWL_WNDPROC,(LONG)OldEditWndProc);
		SetDlgItemText(hWnd,CtrlID,"");	
	}
	else if( InputMode == 1 )//ʮģʽ
	{	
		OldEditWndProc = (WNDPROC)SetWindowLong(GetDlgItem(hWnd,CtrlID),GWL_WNDPROC,(LONG)NewEditWndProc);
		SetWindowLong(GetDlgItem(hWnd,CtrlID),DWL_USER,(LONG)CtrlID);
		SetDlgItemText(hWnd,CtrlID,"");
	}
}